#include "editor.h"

//{{{
int show_dialog(const char *message, int x, int y, int width, int height)
{
	draw_rect(x, y, width, height);
	draw_string(message, x+3, y+3);
	return read_char();
}
//}}}
//{{{
// Reads a string. (Editing support is quite primitive, however, and
// only characters legal in filenames are recognized.)
int dialog_read_string(const char *message, char *buffer, int x, int y,
                       int width, int height)
{
	int key;
	int string_pos = 0;
	draw_rect(x, y, width, height);
	draw_string(message, x+3, y+3);
	
	do
	{
		draw_rect(x+3, y+height-11, width-7, 9);
		draw_string(buffer, x+5, y+height-9);
		key = read_char();
		
		if(key==KEY_BACKSPACE || key==KEY_LEFT)
		{
			if(string_pos>0)
				buffer[--string_pos] = '\0';
		}
		
		if(key==KEY_ENTER)
			return 1;
		if(key==KEY_ESC)
			return 0;
		
	
		if(key>0 && key<256)
		{
			buffer[string_pos++] = key;
			buffer[string_pos] = '\0';
		}
		
	} while(1);
}
//}}}

